#pragma once

#include <QObject>
#include <QList>
template <typename T>
class AutoDeleteList
{
public:
	// Ӷ
	void add(T *obj)
	{
		objs.append(obj);
	}

	// б
	~AutoDeleteList()
	{
		qDeleteAll(objs);
	}

private:
	QList<T *> objs;
};


class ExitManager : public QObject
{
	Q_OBJECT
public:
	// Ҫ˳ʱԶĶ
	template <typename T>
	void add(T *obj)
	{
		autoDeleteList.add(obj);
	}

	// ˳Ӧó
	void exit(int exitCode = 0)
	{
		
		// ˳Ӧóź
		emit exitApplication(exitCode);
	}

signals:
	// ˳Ӧóź
	void exitApplication(int exitCode);

private:
	// Զб
	AutoDeleteList<QObject> autoDeleteList;
};